﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=11.5
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: True
	#IncludeTitle: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim ix_xui As XUI
	Dim is_access As Accessibility
	Dim timer1 As Timer

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim imedia_player As MediaPlayer
	Dim is_currenttime As Long
	Dim is_nexttime As Long
	Dim fileName As String = "alarm_schedule.json"
	Dim filedir As String = File.DirDefaultExternal
	Dim jsonParser As JSONParser
	Dim is_startalarmcount As Int = 0

	Private btn_setalarmtiming As Button
	Private btn_startalarm As Button
	Private ilbl_heading As Label
	Private if_flexgridtabledetailslist As FlexGrid
	Private ilbl_details As Label
	Private ip_detailstablepanel As Panel
	Private btn_savetable As Button
	Private edit_time As EditText
	Private ilbl_minsec As Label
	Private ilbl_time As Label
	Private pnl_minsec As Panel
	Private pnl_time As Panel
	Private spnr_minsec As Spinner
	Private pnl_setalarm As Panel
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("alarm_sound")
	 
	imedia_player.Initialize2("MP")
	timer1.Initialize("Timer1", 1000)
	 
	pnl_setalarm.Visible = False
	
	if_flexgridtabledetailslist.Font = ix_xui.CreateFont(Typeface.DEFAULT, 14/is_access.GetUserFontScale)
	if_flexgridtabledetailslist.HeaderFont = ix_xui.CreateFont(Typeface.DEFAULT, 15/is_access.GetUserFontScale)
	
	if_flexgridtabledetailslist.ColsName = Array As String("S.No", "Time", "Min/Sec")
													   
	if_flexgridtabledetailslist.ColsWidth = Array As Int(100dip, 150dip, 150dip)
														 
	if_flexgridtabledetailslist.ColsType = Array As Int(if_flexgridtabledetailslist.TypeInt, if_flexgridtabledetailslist.TypeInt, if_flexgridtabledetailslist.TypeString)
													
	if_flexgridtabledetailslist.ColsAlignment = Array As String("CENTER", "CENTER", "CENTER")
	
	spnr_minsec.AddAll(Array As String ("Seconds", "Minutes"))
	
	DisplayTableRecords

End Sub

Sub DisplayTableRecords
	If File.Exists(File.DirDefaultExternal, fileName) = True Then
		
		Dim jsonString As String = File.ReadString(filedir, fileName)

		jsonParser.Initialize(jsonString)
		Dim data As List = jsonParser.NextArray
		
		Dim ls_sno As Int = 0
		
		For Each coldata As Map In data
			ls_sno = ls_sno + 1
			
			Dim ls_time As Int = coldata.Get("Time")
			Dim ls_minsec As String = coldata.Get("Min-Sec")
			
			if_flexgridtabledetailslist.AddRow(Array As Object(ls_sno, ls_time, ls_minsec),False)
			if_flexgridtabledetailslist.SetColAlignment(0,"CENTER")
		Next
	End If
End Sub

Sub Activity_Resume
	
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	Log("alarm start count : " & is_startalarmcount)
	
	If is_startalarmcount > 0 Then
		btn_startalarm_Click
	End If

End Sub

Private Sub btn_savetable_Click
	If edit_time.Text == "" Then
		Return
	End If
	
	Dim ls_sno As Int = 0
	
	If if_flexgridtabledetailslist.RowCount == 0 Then
		ls_sno = 0
	Else If if_flexgridtabledetailslist.RowCount > 0 Then
		For i = 0 To if_flexgridtabledetailslist.RowCount - 1
			ls_sno = if_flexgridtabledetailslist.GetCellValue(i,0)
		Next
	End If
	
	Dim row(3) As Object
	
	row(0) = ls_sno + 1
	row(1) = edit_time.Text.Trim
	row(2) = spnr_minsec.SelectedItem
	
	if_flexgridtabledetailslist.AddRow(row, False)
	if_flexgridtabledetailslist.SetColAlignment(0,"CENTER")
	
	pnl_setalarm.Visible = False
	btn_setalarmtiming.Enabled = True
	btn_startalarm.Enabled = True
	
	edit_time.Text = ""
	
	DatatoJSON
	
End Sub

Private Sub btn_setalarmtiming_Click
	pnl_setalarm.Visible = True
	btn_setalarmtiming.Enabled = False
	btn_startalarm.Enabled = False
	
End Sub

Private Sub btn_startalarm_Click
	is_startalarmcount = is_startalarmcount + 1
	timer1.Enabled = False 
	For i = 0 To if_flexgridtabledetailslist.RowCount - 1
		Dim rowdata As List = if_flexgridtabledetailslist.GetCellRow(i)
        
		Dim ls_time As String = rowdata.Get(1)
		Dim ls_minsec As String = rowdata.Get(2)
        
		Log("Row " & i & " Time: " & ls_time & " " & ls_minsec)
        
		Dim p As Period
		If ls_minsec == "Minutes" Then
			p.Minutes = ls_time
		Else If ls_minsec == "Seconds" Then
			p.Seconds = ls_time
		End If
       
		is_currenttime = DateTime.Now
		is_nexttime = DateUtils.AddPeriod(DateTime.Now, p)
        
		Log("Current time: " & DateTime.Time(is_currenttime))
		Log("Next alarm time: " & DateTime.Time(is_nexttime))
        
		WaitForTimeAndPlayAlarm
	Next
	
'	Activity.Finish
End Sub

Sub WaitForTimeAndPlayAlarm
	Do While DateTime.Now < is_nexttime
		DoEvents
	Loop
    
	' When the time has elapsed, play the alarm
	Timer1_Tick
End Sub

Sub Timer1_Tick
	' Play the alarm sound
	imedia_player.Load(File.DirAssets, "beepsound.mp3")
	imedia_player.Play
	Log("Alarm played!")
End Sub

Sub DatatoJSON
	Dim list_data As List
	list_data.Initialize
    
	' Iterate through the FlexGrid rows
	For i = 0 To if_flexgridtabledetailslist.RowCount - 1
		Dim rowdata As List = if_flexgridtabledetailslist.GetCellRow(i)
        
		' Assuming row contains data like [id, time, minSec]
		Dim map_data As Map
		map_data.Initialize
		map_data.Put("Time", rowdata.Get(1))       ' Column 2 data
		map_data.Put("Min-Sec", rowdata.Get(2))     ' Column 3 data
        
		' Add the map (row) to the list
		list_data.Add(map_data)
	Next
    
	' Convert the list to JSON
	Dim json As JSONGenerator
	json.Initialize2(list_data)
	Dim jsonString As String = json.ToString
	Log(jsonString)
	
	Dim lr_runtimepermission As RuntimePermissions
	lr_runtimepermission.GetSafeDirDefaultExternal("")
	
	File.WriteString(filedir, fileName, jsonString)
	
End Sub

Private Sub if_flexgridtabledetailslist_CellLongClick(Row As Int, Col As Int)
		
	Msgbox2Async("Do You Want to Delete This Row?", "Attention!!", "Yes", "", "No", Null, False)
	Wait For Msgbox_Result (Result As Int)
	
	If Result == DialogResponse.POSITIVE Then
		if_flexgridtabledetailslist.RemoveRow(Row)
		DatatoJSON
	End If

	
	
End Sub