﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=11.5
@EndOfDesignText@
Sub Process_Globals
	Private Timer1 As Timer
	Private is_nexttime As Long
	Private rowdata As List
	Private currentRow As Int
	
End Sub

Sub Globals
	Dim if_flexgridtabledetailslist As FlexGrid
End Sub

Sub Activity_Create(FirstTime As Boolean)
	' Initialize the Timer
	Timer1.Initialize("Timer1", 1000) ' 1 second interval
End Sub

Private Sub btn_startalarm_Click
	For i = 0 To if_flexgridtabledetailslist.RowCount - 1
		rowdata = if_flexgridtabledetailslist.GetCellRow(i) ' Get the row data
        
		Dim ls_time As String = rowdata.Get(1) ' Time value (number)
		Dim ls_minsec As String = rowdata.Get(2) ' "Minutes" or "Seconds"
        
		Log("Processing row: " & i & " - Time: " & ls_time & " " & ls_minsec)
        
		Dim p As Period
		If ls_minsec == "Minutes" Then
			p.Minutes = ls_time
		Else If ls_minsec == "Seconds" Then
			p.Seconds = ls_time
		End If
        
		' Get current time and calculate next time for alarm
		is_nexttime = DateUtils.AddPeriod(DateTime.Now, p)
		Log("Next Alarm Time for Row " & i & ": " & DateTime.Time(is_nexttime))
        
		Timer1.Enabled = True ' Start the timer
	Next
End Sub

Sub Timer1_Tick
	Dim currentTime As Long = DateTime.Now
    
	' If current time reaches or passes the next alarm time
	If currentTime >= is_nexttime Then
		Log("Beep! Time reached for row: " & currentRow)
        
		' Play the alarm sound
		PlayAlarm
        
		' Proceed to the next row in the loop
		currentRow = currentRow + 1
        
		' If there are more rows, process the next
		If currentRow < if_flexgridtabledetailslist.RowCount Then
			rowdata = if_flexgridtabledetailslist.GetCellRow(currentRow)
            
			Dim ls_time As String = rowdata.Get(1)
			Dim ls_minsec As String = rowdata.Get(2)
            
			Dim p As Period
			If ls_minsec == "Minutes" Then
				p.Minutes = ls_time
			Else If ls_minsec == "Seconds" Then
				p.Seconds = ls_time
			End If
            
			is_nexttime = DateUtils.AddPeriod(DateTime.Now, p)
			Log("Next Alarm Time for Row " & currentRow & ": " & DateTime.Time(is_nexttime))
		Else
			Timer1.Enabled = False ' Stop the timer after all rows are processed
		End If
	End If
End Sub

Sub PlayAlarm
	' Play the alarm sound
	Dim imedia_player As MediaPlayer
	imedia_player.Initialize()
	imedia_player.Load(File.DirAssets, "beepsound.mp3")
	imedia_player.Play
End Sub

' Include these libraries in your project: RandomAccessFile, File

Sub SaveFlexGridToJSON
	' Initialize a list to hold all rows
	Dim jsonList As List
	jsonList.Initialize
    
	' Iterate through the FlexGrid rows
	For i = 0 To if_flexgridtabledetailslist.RowCount - 1
		Dim rowdata As List = if_flexgridtabledetailslist.GetCellRow(i)
        
		' Assuming row contains data like [id, time, minSec]
		Dim dataMap As Map
		dataMap.Initialize
		dataMap.Put("id", rowdata.Get(0))         ' Column 1 data
		dataMap.Put("time", rowdata.Get(1))       ' Column 2 data
		dataMap.Put("minSec", rowdata.Get(2))     ' Column 3 data
        
		' Add the map (row) to the list
		jsonList.Add(dataMap)
	Next
    
	' Convert the list to JSON
	Dim json As JSONGenerator
	json.Initialize(jsonList)
	Dim jsonString As String = json.ToString
    
	' Log the JSON to check its format
	Log(jsonString)
    
	' Write JSON to file
	Dim packageName As String = Application.PackageName
	Dim fileName As String = "flexgrid_data.json"
    
	' Save the file to the app's private internal storage (or File.DirRootExternal for external storage)
	File.WriteString(File.DirInternal, fileName, jsonString)
    
	' Log the path where the file is saved
	Log("JSON file saved at: " & File.Combine(File.DirInternal, fileName))
End Sub

